# InitialConditionsAdisTSSpec.py -- Pamhyr
# Copyright (C) 2023-2026  INRAE
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

# -*- coding: utf-8 -*-

import logging

from tools import trace, timer

from Model.Tools.PamhyrDB import SQLSubModel
from Model.Except import NotImplementedMethodeError
from Model.Scenario import Scenario

logger = logging.getLogger()


class ICAdisTSSpec(SQLSubModel):
    _sub_classes = []

    def __init__(self, id: int = -1, name: str = "",
                 status=None, owner_scenario=None):
        super(ICAdisTSSpec, self).__init__()

        self._status = status

        self._name_section = name
        self._reach = None
        self._start_rk = None
        self._end_rk = None
        self._concentration = None
        self._eg = None
        self._em = None
        self._ed = None
        self._rate = None
        self._enabled = True

    @classmethod
    def _db_create(cls, execute, ext=""):
        execute(f"""
          CREATE TABLE initial_conditions_adists_spec{ext}(
            {cls.create_db_add_pamhyr_id()},
            deleted BOOLEAN NOT NULL DEFAULT FALSE,
            ic_default INTEGER NOT NULL,
            name TEXT NOT NULL,
            reach INTEGER NOT NULL,
            start_rk REAL NOT NULL,
            end_rk REAL NOT NULL,
            concentration REAL NOT NULL,
            eg REAL NOT NULL,
            em REAL NOT NULL,
            ed REAL NOT NULL,
            rate REAL NOT NULL,
            enabled BOOLEAN NOT NULL,
            {Scenario.create_db_add_scenario()},
            {Scenario.create_db_add_scenario_fk()},
            FOREIGN KEY(ic_default)
              REFERENCES initial_conditions_adists(pamhyr_id),
            FOREIGN KEY(reach) REFERENCES river_reach(pamhyr_id)
          )
        """)

        return cls._create_submodel(execute)

    @classmethod
    def _db_update(cls, execute, version, data=None):
        major, minor, release = version.strip().split(".")

        if major == "0" and int(minor) < 2:
            if cls.is_table_exists(execute, "initial_conditions_adists_spec"):
                cls._db_update_to_0_2_0(execute, data)
            else:
                cls._db_create(execute)

        return True

    @classmethod
    def _db_update_to_0_2_0(cls, execute, data):
        table = "initial_conditions_spec"
        table_new = "initial_conditions_adists_spec"
        reachs = data['id2pid']['river_reach']

        cls.update_db_add_pamhyr_id(execute, table, data)
        Scenario.update_db_add_scenario(execute, table)

        cls._db_create(execute, ext="_tmp")

        execute(
            f"INSERT INTO {table_new}_tmp " +
            "(pamhyr_id, ic_default, name, reach, start_rk, end_rk, " +
            "concentration, eg, em, ed, rate, enabled, scenario) " +
            "SELECT pamhyr_id, ic_default, name, reach, start_rk, end_rk, " +
            "concentration, eg, em, ed, rate, enabled, scenario " +
            f"FROM {table}"
        )

        execute(f"DROP TABLE {table}")
        execute(f"ALTER TABLE {table_new}_tmp RENAME TO {table_new}")

        cls._db_update_to_0_2_0_set_reach_pid(execute, table_new, reachs)
        cls._db_update_to_0_2_0_set_ica_pid(execute, data)

    @classmethod
    def _db_update_to_0_2_0_set_ica_pid(cls, execute, data):
        pid_ica = data["id2pid"]["initial_conditions_adist"]
        els = execute(
            "SELECT pamhyr_id, ic_default " +
            "FROM initial_conditions_adists_spec"
        )

        for row in els:
            it = iter(row)
            pid = next(it)
            ica_id = next(it)

            if ica_id == -1:
                continue

            execute(
                f"UPDATE initial_conditions_adists_spec " +
                f"SET ic_default = {pid_ica[ica_id]} " +
                f"WHERE pamhyr_id = {pid}"
            )

    @classmethod
    def _db_load(cls, execute, data=None):
        new = []
        status = data['status']
        reachs = data["edges"]
        scenario = data["scenario"]
        loaded = data['loaded_pid']

        if scenario is None:
            return new

        table = execute(
            "SELECT pamhyr_id, deleted, name, reach, start_rk, end_rk, " +
            "concentration, eg, em, ed, rate, enabled, scenario " +
            "FROM initial_conditions_adists_spec " +
            f"WHERE ic_default = {data['ic_default_id']} " +
            f"AND scenario = {scenario.id} " +
            f"AND pamhyr_id NOT IN ({', '.join(map(str, loaded))}) "
        )

        if table is not None:
            for row in table:
                it = iter(row)

                id = next(it)
                deleted = (next(it) == 1)
                name = next(it)
                reach = next(it)
                start_rk = next(it)
                end_rk = next(it)
                concentration = next(it)
                eg = next(it)
                em = next(it)
                ed = next(it)
                rate = next(it)
                enabled = (next(it) == 1)
                owner_scenario = next(it)

                new_spec = cls(
                    id=id, name=name,
                    status=status,
                    owner_scenario=owner_scenario
                )
                if deleted:
                    new_spec.set_as_deleted()

                new_spec.reach = reach
                new_spec.start_rk = start_rk
                new_spec.end_rk = end_rk
                new_spec.concentration = concentration
                new_spec.eg = eg
                new_spec.em = em
                new_spec.ed = ed
                new_spec.rate = rate
                new_spec.enabled = enabled

                # loaded.add(pid)
                new.append(new_spec)

        data["scenario"] = scenario.parent
        new += cls._db_load(execute, data)
        data["scenario"] = scenario

        return new

    def _db_save(self, execute, data=None):
        if not self.must_be_saved():
            return True

        ic_default = data['ic_default_id']

        sql = (
            "INSERT INTO " +
            "initial_conditions_adists_spec(pamhyr_id, deleted, " +
            "ic_default, name, reach, " +
            "start_rk, end_rk, concentration, eg, em, ed, rate, " +
            "enabled, scenario) " +
            "VALUES (" +
            f"{self.id}, {self._db_format(self.is_deleted())}, " +
            f"{ic_default}, " +
            f"'{self._db_format(self._name_section)}', " +
            f"{self._reach}, " +
            f"{self._start_rk}, {self._end_rk}, " +
            f"{self._concentration}, " +
            f"{self._eg}, {self._em}, {self._ed}, " +
            f"{self._rate}, {self._enabled}, " +
            f"{self._status.scenario_id}" +
            ")"
        )
        execute(sql)

        return True

    @property
    def name(self):
        return self._name_section

    @name.setter
    def name(self, name):
        self._name_section = name
        self._status.modified()

    @property
    def reach(self):
        return self._reach

    @reach.setter
    def reach(self, reach):
        self._reach = reach
        self._status.modified()

    @property
    def start_rk(self):
        return self._start_rk

    @start_rk.setter
    def start_rk(self, start_rk):
        self._start_rk = start_rk
        self._status.modified()

    @property
    def end_rk(self):
        return self._end_rk

    @end_rk.setter
    def end_rk(self, end_rk):
        self._end_rk = end_rk
        self._status.modified()

    @property
    def concentration(self):
        return self._concentration

    @concentration.setter
    def concentration(self, concentration):
        self._concentration = concentration
        self._status.modified()

    @property
    def eg(self):
        return self._eg

    @eg.setter
    def eg(self, eg):
        self._eg = eg
        self._status.modified()

    @property
    def em(self):
        return self._em

    @em.setter
    def em(self, em):
        self._em = em
        self._status.modified()

    @property
    def ed(self):
        return self._ed

    @ed.setter
    def ed(self, ed):
        self._ed = ed
        self._status.modified()

    @property
    def rate(self):
        return self._rate

    @rate.setter
    def rate(self, rate):
        self._rate = rate
        self._status.modified()

    @property
    def enabled(self):
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        self._enabled = enabled
        self._status.modified()
